import FSM
import utils as u
import menus as m
import pygame
import glob
import os

#====================================     

State = type("State", (object,), {})
#====================================     
class State(object):
	def __init__(self, FSM):
		self.FSM = FSM
	def Enter(self):
		pass
	def Execute(self):
		pass
	def Exit(self):
		pass

class SelTheme(State):
	def __init__(self,FSM):
		super(SelTheme, self).__init__(FSM)    
		
	def Enter(self):
		o = self.FSM.owner
		o.header_text = "Select Theme"
		o.pub.register("beat", self)
		self.cur_el = 0
		self.globbed = glob.glob('/home/pi/zpc_ct/user/themes/*.thm')
		self.globbed.sort()
		self.names = [os.path.basename(x) for x in self.globbed]
		self.names = [os.path.splitext(x)[0] for x in self.names]
		if o.mconf['theme'] in self.names:
			_id = self.names.index(o.mconf['theme'])
			self.cur_el = _id
		else:
			print('nope ', o.mconf['theme'], ' - ', self.globbed)
		self.menu = self.names

		if o.keyState[16] > 0 or o.keyState[17] > 0:
			pass
		else:
			u.draw_header(o)
			self.draw_main(o)			
			
			o.update_display(0)
		super(SelTheme, self).Enter()    

	def Execute(self):
		o = self.FSM.owner 
		m.menu1_actions(self, o)
		if o.keyState[16] == 1:
			m.draw_menu1(o)
			o.update_display(0)
		elif o.keyState[16] == 4:
			u.draw_header(o)
			self.draw_footer(o)
			self.draw_main(o)
			o.update_display(0)

		if o.keyState[0] == 1 or o.keyState[0] == 3 or o.keyState[1] == 1 or o.keyState[1] == 3 or o.keyState[2] == 1 or o.keyState[2] == 3 or o.keyState[3] == 1 or o.keyState[3] == 3:
			u.draw_header(o)
			self.draw_footer(o)
			self.draw_main(o)
			o.update_display(0)	
			print('draw butt')				

		if o.keyState[16] > 0 or o.keyState[17] > 0:
			pass
		else:
			if o.keyState[0] == 1:
				if self.cur_el > 0:
					self.cur_el -= 1
					o.mconf['theme'] = self.menu[self.cur_el]					
					o.save_config()
					o.load_config()
					o.apply_theme()
					print('cur el down is ', self.cur_el)

			if o.keyState[1] == 1:
				if self.cur_el < (len(self.menu) - 1):
					self.cur_el += 1
					o.mconf['theme'] = self.menu[self.cur_el]					
					o.save_config()
					o.load_config()
					o.apply_theme()
					print('cur el up is ', self.cur_el)
					print('loading theme ', self.menu[self.cur_el], '-- ', o.mconf['theme'])

			if o.keyState[3] == 1:
				m.util_command(self, o, self.menu[self.cur_el])

	def draw_main(self, o):
		al = []
		ypos = 30
		if self.cur_el == 0:
			_iter = 0
			while len(al) < 4:
				al.append(self.menu[_iter])
				_iter += 1
		elif self.cur_el == 1:
			al.append(self.menu[self.cur_el - 1])
			al.append(self.menu[self.cur_el])
			al.append(self.menu[self.cur_el + 1])
			al.append(self.menu[self.cur_el + 2])
		elif self.cur_el == (len(self.menu) - 2):
			al.append(self.menu[self.cur_el - 2])
			al.append(self.menu[self.cur_el - 1])
			al.append(self.menu[self.cur_el])
			al.append(self.menu[self.cur_el + 1])
		elif self.cur_el == (len(self.menu) - 1):
			al.append(self.menu[self.cur_el - 3])
			al.append(self.menu[self.cur_el - 2])
			al.append(self.menu[self.cur_el - 1])
			al.append(self.menu[self.cur_el])
		else:
			al.append(self.menu[self.cur_el - 1])
			al.append(self.menu[self.cur_el])
			al.append(self.menu[self.cur_el + 1])
			al.append(self.menu[self.cur_el + 2])
		_iter = 0 
		for i in al:
			if i == self.menu[self.cur_el]:
				o.draw.rectangle((0, ypos, o.width, ypos + 20), outline=0, fill=o.light_grey)
				o.center_block(i, o.h2, [0, ypos, o.width,ypos + 20], o.blue)
			else:
				o.draw.rectangle((0, ypos, o.width, ypos + 20), outline=0, fill=o.blue)
				o.center_block(i, o.h2, [0, ypos, o.width,ypos + 20], o.light_grey)
			ypos += 20
			_iter += 1		    

	def draw_footer(self, o):
		_iter = 0
		width = o.width / 4
		xpos = 0
		yposa = 135 - 25
		yposb = 135
		opts = ["Up", "Down", "", ""]
		while _iter < 4:
			o.draw.rectangle((xpos, yposa, xpos + width, yposb), outline=0, fill=o.blue)
			
			if o.keyState[_iter] == 1:
				o.draw.rectangle((xpos, yposa, xpos + width, yposb), outline=0, fill=o.light_grey)
				o.center_block(opts[_iter], o.h2, [xpos,yposa,xpos + width,yposb], o.blue)
			else:
				o.center_block(opts[_iter], o.h2, [xpos,yposa,xpos + width,yposb], o.light_grey)
			
			xpos += width
			_iter += 1
		

	def ReceiveMessage(self, message):
		o = self.FSM.owner 
		u.play_seq(o, message)
		
	def Exit(self):
		self.FSM.owner.pub.unregister("beat", self)
