import FSM
import utils as u
import menus as m
#====================================     

State = type("State", (object,), {})
#====================================     
class State(object):
	def __init__(self, FSM):
		self.FSM = FSM
	def Enter(self):
		pass
	def Execute(self):
		pass
	def Exit(self):
		pass

#==================================== 
			
class SelectPattern(State):
	def __init__(self,FSM):
		super(SelectPattern, self).__init__(FSM)    
		
	def Enter(self):
		self.FSM.stateLife = 1
		o = self.FSM.owner 
		o.header_text = "Select Pattern"
		o.pub.register("beat", self)
		self.cur_playing = 0
		self.active_patterns = []
		self.get_active_patterns(o)

		if o.keyState[16] > 0 or o.keyState[17] > 0:
			pass
		else:
			u.draw_header(o)
			self.draw_square()
			u.text_box1(o, "Pat", str(o.ePattern))
			u.text_box4(o, "Bank", str(o.pat_bank))
			o.update_display(0)
		
		super(SelectPattern, self).Enter()        
		
	def Execute(self):
		o = self.FSM.owner 
		m.menu1_actions(self, o)
		m.menu2_actions_pattern(self, o)
		if o.keyState[16] == 1:
			m.draw_menu1(o)
			o.update_display(0)
		elif o.keyState[16] == 4:
			u.draw_header(o)
			self.draw_square()
			u.text_box1(o, "Pat", str(o.ePattern))
			u.text_box4(o, "Bank", str(o.pat_bank))
			o.update_display(0)

		if o.keyState[17] == 1:
			m.draw_menu2_pattern(o)
			o.update_display(0)
		elif o.keyState[17] == 4:
			u.draw_header(o)
			self.get_active_patterns(o)
			self.draw_square()
			u.text_box1(o, "Pat", str(o.ePattern))
			u.text_box4(o, "Bank", str(o.pat_bank))
			o.update_display(0)

		if o.keyState[16] > 0 or o.keyState[17] > 0:
			pass
		else:
			_id = 0
			for k in o.keyState:
				if _id > 15:
					pass
				else:
					if k == 1:
						o.ePattern = (o.pat_bank * 16) +_id 

						u.draw_header(o)
						self.draw_square()
						
						u.text_box1(o, "Pat", str(o.ePattern))
						u.text_box4(o, "Bank", str(o.pat_bank))
						o.update_display(0)
				_id += 1        

	def ReceiveMessage(self, message):
		o = self.FSM.owner
		u.play_seq(o, message) 
		
		if message[0] != self.cur_playing:
			self.cur_playing = message[0]
			if o.keyState[16] > 0 or o.keyState[17] > 0:
				pass
			else:
				u.draw_header(o)
				self.draw_square()
				u.text_box1(o, "Pat", str(o.ePattern))
				u.text_box4(o, "Bank", str(o.pat_bank))
				o.update_display(0)

	def draw_square(self):
		o = self.FSM.owner 
		size = 22
		og_x = (o.width / 2) - (size * 2)
		o_x = og_x
		o_y = 127
		_id = 0
		for n in o.soundSlots[o.eSound].notes[o.ePattern]:
			if (_id + (o.pat_bank * 16)) == o.ePattern:
				o.draw.rectangle((o_x, o_y, o_x + size, o_y - size), outline=o.light_grey, fill=o.olive, width=1)
			elif (_id + (o.pat_bank * 16)) == self.cur_playing:
				o.draw.rectangle((o_x, o_y, o_x + size, o_y - size), outline=o.light_grey, fill=o.light_grey, width=1)
			elif self.active_patterns[_id] == 1:
				o.draw.rectangle((o_x, o_y, o_x + size, o_y - size), outline=o.light_grey, fill=o.blue, width=1)
			else:
				o.draw.rectangle((o_x, o_y, o_x + size, o_y - size), outline=o.light_grey, fill=o.dark_grey, width=1)
			o_x = o_x + size
			_id += 1
			if _id % 4 == 0:
				o_y -= size
				o_x = og_x          

	def get_active_patterns(self, o):
		self.active_patterns = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
		pat_iter = o.pat_bank * 16
		_iter = 0
		while pat_iter < ((o.pat_bank * 16) + 16):
			for s in o.soundSlots:
				pat_used = 0
				for p in s.notes[pat_iter]:
					if self.active_patterns[_iter] == 1:
						break
					if p[0] == 1:
						self.active_patterns[_iter] = 1
						break
			pat_iter += 1
			_iter += 1
	
	def Exit(self):
		self.FSM.owner.pub.unregister("beat", self)
